#include <iostream>
#include <vector>

#include <sys/mman.h>
#include <unistd.h>

const int maxAllocSize(1024*1024);

long long MlockMax()
{
   long long allocated(0);
   int toalloc(maxAllocSize);

   while (true)
   {
      void *p(malloc(toalloc));
      if (!p)
      {
         std::cout <<"malloc failed" <<std::endl;
         return allocated;
      }

      if (mlock(p, toalloc))
      {
         std::cout <<"mlock failed" <<std::endl;

         toalloc /= 2;

         if (!toalloc)
            return allocated;
      }
      else
         allocated += toalloc;

      std::cout <<"mlocked: " <<allocated <<'\t';
      std::cout <<"toalloc: " <<toalloc <<std::endl;
   }
}

void MallocMax(long long allocAmount)
{
   long long allocated(0);
   int toalloc(maxAllocSize);

   while (allocated < allocAmount)
   {
      void *p(malloc(toalloc));
      if (!p)
      {
         std::cout <<"malloc failed" <<std::endl;

         toalloc /= 2;

         if (!toalloc)
            return;
      }
      else
      {
         memset(p, 0, toalloc);
         allocated += toalloc;
      }

      std::cout <<"malloced: " <<allocated <<'\t';
      std::cout <<"toalloc: " <<toalloc <<std::endl;
   }
}

int main()
{
   long long locked(MlockMax());
   MallocMax(locked);
   sleep(1);
}
